*** check_ntp   Wed Nov 27 11:21:45 2002
--- check_ntp2  Wed Nov 27 12:57:11 2002
***************
*** 120,131 ****
  my $dispersion_error = $ERRORS{'UNKNOWN'};

  my $key = undef;
! # some systems don't have a proper ntpdc/xntpdc
! my $have_ntpdc = undef;
! if ($utils::PATH_TO_NTPDC && -x $utils::PATH_TO_NTPDC ) {
!       $have_ntpdc = 1;
  }else{
!       $have_ntpdc = 0;
  }

  # Just in case of problems, let's not hang Nagios
--- 120,131 ----
  my $dispersion_error = $ERRORS{'UNKNOWN'};

  my $key = undef;
! # some systems don't have a proper ntpq
! my $have_ntpq = undef;
! if ($utils::PATH_TO_NTPQ && -x $utils::PATH_TO_NTPQ ) {
!       $have_ntpq = 1;
  }else{
!       $have_ntpq = 0;
  }

  # Just in case of problems, let's not hang Nagios
***************
*** 180,193 ****

  ###
  ###
! ### Then scan xntpdc/ntpdc if it exists
  ### and look in the 8th column for dispersion (ntpd v4) or jitter (ntpd v3)
  ###

! if ($have_ntpdc) {

!       if ( open(NTPDC,"$utils::PATH_TO_NTPDC -s $host 2>&1 |") ) {
!               while (<NTPDC>) {
                        print $_ if ($verbose);
                        if (/([^\s]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)/) {
                                if ($8 gt $critical) {
--- 180,193 ----

  ###
  ###
! ### Then scan ntpq if it exists
  ### and look in the 8th column for dispersion (ntpd v4) or jitter (ntpd v3)
  ###

! if ($have_ntpq) {

!       if ( open(NTPQ,"$utils::PATH_TO_NTPQ -c pe $host 2>&1 |") ) {
!               while (<NTPQ>) {
                        print $_ if ($verbose);
                        if (/([^\s]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)\s+([-0-9.]+)/) {
                                if ($8 gt $critical) {
***************
*** 201,207 ****
                                }
                        }
                }
!               close NTPDC;
        }
  }

--- 201,207 ----
                                }
                        }
                }
!               close NTPQ;
        }
  }

***************
*** 216,222 ****
                $answer = "Server error and time difference $offset seconds greater than +/- $warning sec\n";
        }

! } elsif ($have_ntpdc && $dispersion_error != $ERRORS{'OK'}) {
        $state = $dispersion_error;
        $answer = "Dispersion too high\n";
        if (defined($offset) && abs($offset) > $critical) {
--- 216,222 ----
                $answer = "Server error and time difference $offset seconds greater than +/- $warning sec\n";
        }

! } elsif ($have_ntpq && $dispersion_error != $ERRORS{'OK'}) {
        $state = $dispersion_error;
        $answer = "Dispersion too high\n";
        if (defined($offset) && abs($offset) > $critical) {
***************
*** 226,232 ****
                $answer = "Dispersion error and time difference $offset seconds greater than +/- $warning sec\n";
        }

! } else { # no errors from ntpdate or xntpdc
        if (defined $offset) {
                if (abs($offset) > $critical) {
                        $state = $ERRORS{'CRITICAL'};
--- 226,232 ----
                $answer = "Dispersion error and time difference $offset seconds greater than +/- $warning sec\n";
        }

! } else { # no errors from ntpdate or ntpq
        if (defined $offset) {
                if (abs($offset) > $critical) {
                        $state = $ERRORS{'CRITICAL'};
***************
*** 265,270 ****
        print "<warn> = Clock offset in seconds at which a warning message will be generated.\n Defaults to 60.\n";
        print "<crit> = Clock offset in seconds at which a critical message will be generated.\n        Defaults to 120.\n\n";
        print "The same warning and critical values are used to check against the dispersion \n";
!       print "column of ntpdc/xntpdc for the host being queried.\n\n";
        support();
  }
--- 265,270 ----
        print "<warn> = Clock offset in seconds at which a warning message will be generated.\n Defaults to 60.\n";
        print "<crit> = Clock offset in seconds at which a critical message will be generated.\n        Defaults to 120.\n\n";
        print "The same warning and critical values are used to check against the dispersion \n";
!       print "column of ntpq for the host being queried.\n\n";
        support();
  }

